diff --git a/res/res_pjsip/pjsip_transport_events.c b/res/res_pjsip/pjsip_transport_events.c
index c701b84..b16729b 100644
--- a/res/res_pjsip/pjsip_transport_events.c
+++ b/res/res_pjsip/pjsip_transport_events.c
@@ -272,6 +272,10 @@ void ast_sip_transport_monitor_unregister(pjsip_transport *transport,
 		};
 
 		transport_monitor_unregister_cb(monitored, &cb_data, 0);
+		
+		/* Decrement pjsip transport ref */
+		pjsip_transport_dec_ref(monitored->transport);
+		
 		ao2_ref(monitored, -1);
 	}
 	ao2_unlock(transports);
@@ -300,6 +304,9 @@ enum ast_transport_monitor_reg ast_sip_transport_monitor_register(pjsip_transpor
 		/* Add new monitor to vector */
 		new_monitor.cb = cb;
 		new_monitor.data = ao2_bump(ao2_data);
+		
+		
+		
 		if (AST_VECTOR_APPEND(&monitored->monitors, new_monitor)) {
 			ao2_cleanup(ao2_data);
 			res = AST_TRANSPORT_MONITOR_REG_FAILED;
@@ -307,6 +314,10 @@ enum ast_transport_monitor_reg ast_sip_transport_monitor_register(pjsip_transpor
 				cb, ao2_data, transport->obj_name);
 		} else {
 			res = AST_TRANSPORT_MONITOR_REG_SUCCESS;
+			
+			/* Add pjsip transport ref */
+			pjsip_transport_add_ref(monitored->transport);
+			
 			ast_debug(3, "Registered monitor %p(%p) to transport %s\n",
 				cb, ao2_data, transport->obj_name);
 		}
